import { Request, Response } from "express";
import User from "../entities/user";
import UserService from "../services/userService";
import GenericController from "./GenericController";
import { UserViewModel } from "../viewmodels/userModel";
import UserFactory from "../factories/userFactory";

export default class UserController extends GenericController<UserService, UserFactory, User, UserViewModel> {
  constructor() {
    super(new UserService(), new UserFactory());
  }

  // overwrite defined generic controller function
  async getById(req: Request, res: Response): Promise<void> {
    res.send("overwritten getById");
  }

  // extend generic controller by specific function
  async getUserByFirstname(req: Request, res: Response): Promise<void> {
    let data: Array<User> = await this.service.getUsersByFirstname(req.params.firstname);
    res.json(data);
  }
}
