import User from "../entities/user";
import { UserViewModel } from "../viewmodels/userModel";
import GenericFactory from "./GenericFactory";

export default class UserFactory implements GenericFactory<User, UserViewModel> {
  mapSingle(row: User): UserViewModel {
    return {
      id: row.id,
      firstname: row.firstname,
    };
  }

  mapArray(rows: User[]): UserViewModel[] {
    return rows.map((r) => this.mapSingle(r));
  }

  mapWithX(row: User): Array<{ id: string }> {
    return [];
  }
}
