import express from "express";
import GenericController from "../controller/GenericController";
import GenericService from "../services/GenericService";
import BaseEntity from "../entities/baseEntity";
import { GenericViewModel } from "../viewmodels/GenericModel";
import GenericFactory from "../factories/GenericFactory";

export default class GenericRouter<
  Controller extends GenericController<Service, Factory, Repository, ViewModel>,
  Service extends GenericService<Repository>,
  Factory extends GenericFactory<Repository, ViewModel>,
  Repository extends BaseEntity,
  ViewModel extends GenericViewModel
> {
  public router = express.Router({ mergeParams: true });
  constructor(protected controller: Controller) {
    this.router.get("/", (req, res) => this.controller.getAll(req, res));
    this.router.get("/:id", (req, res) => this.controller.getById(req, res));
  }
}
