import UserController from "../controller/userController";
import User from "../entities/user";
import UserFactory from "../factories/userFactory";
import UserService from "../services/userService";
import { UserViewModel } from "../viewmodels/userModel";
import GenericRouter from "./GenericRouter";

export default class UserRouter extends GenericRouter<UserController, UserService, UserFactory, User, UserViewModel> {
  constructor() {
    super(new UserController());
    // extend generic routes by specific routes
    this.router.get("/name/:firstname", (req, res) => this.controller.getUserByFirstname(req, res));
  }
}
